/***************************************************************************
 *   Copyright (C) 2005 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "wnnplugin.h"

HonokaPluginRegister(WnnPlugin);

WnnPlugin::WnnPlugin(ConfigPointer cfg) : HonokaMultiplePluginBase(cfg)
{
    predictor = 0;
    convertor = new WnnConversion(cfg);
    
    bool yosoku = cfg->read(String(HONOKA_CONFIG_WNNYOSOKU),HONOKA_DEFAULT_WNNYOSOKU);
    String sType = cfg->read(String(HONOKA_CONFIG_JSERVERTYPE),String(HONOKA_DEFAULT_JSERVERTYPE));
    if (yosoku && (sType == String("Wnn7"))) {
        predictor = new WnnPrediction(cfg,convertor);
    }
}


WnnPlugin::~WnnPlugin()
{
    if (predictor) delete predictor;
    delete convertor;
}

/*!
    \fn WnnPlugin::getPluginInstanceAt(int p)
 */
HonokaPluginBase * WnnPlugin::getPluginInstanceAt(int p)
{
    if (p == 0) return convertor;
    if ((p == 1) && predictor) return predictor;
    return 0;
}


/*!
    \fn WnnPlugin::getPluginCount()
 */
int WnnPlugin::getPluginCount()
{
    if (predictor) return 2;
    return 1;
}

/*!
    \fn WnnPlugin::getName()
 */
String WnnPlugin::getName()
{
    return String("WnnPlugin");
}

